/*
 * config.hpp
 *
 *  Created on: Dec 31, 2023
 *      Author: Dario
 */

#ifndef STA_CONFIG_HPP
#define STA_CONFIG_HPP

#define STA_STM32_SWD_USART_IDX 2

#include <sta/devices/stm32/mcu/STM32F411xE.hpp>

// Doesn't really do too much right now. Has to be added for successful compilation.
#define STA_PRINTF_USE_STDLIB

// Enable debug serial output and assertions.
#define STA_ASSERT_FORCE
#define STA_DEBUGGING_ENABLED

// Use the default configs for TACOS
#include <sta/tacos/configs/default.hpp>

#define STA_TACOS_WATCHDOG_ENABLED
#define STA_TACOS_WATCHDOG_FREQUENCY 1000
#define STA_TACOS_NUM_STATES 8

#endif // STA_CONFIG_HPP
