/**
 * Check if timed transitions work correctly.
 */
#include <sta/tasty/config.hpp>
#ifdef TASTY_CASE_2

#include <sta/tacos.hpp>
#include <sta/tasty/utils.hpp>

namespace sta
{
	namespace tasty
	{
		class DummyThread : public tacos::TacosThread
		{
		private:
			/* data */
		public:
			DummyThread()
				: tacos::TacosThread{"Dummy", osPriorityNormal}
			{}

			void func() override 
			{
				STA_TASTY_INIT();

				STA_TASTY_ASSERT(tacos::getState() == 0);

                // Schedule a state transition in 100 ticks.
                tacos::setStateTimed(0, 1, 100);

                // The state transition shouldn't have happened yet...
                STA_TASTY_ASSERT(tacos::getState() == 0);

                this->sleep(50);

                // ... and still not
                STA_TASTY_ASSERT(tacos::getState() == 0);

                this->sleep(40);

                // ... and still not
                STA_TASTY_ASSERT(tacos::getState() == 0);

                this->sleep(3);

                // Now it should have happened
                STA_TASTY_ASSERT(tacos::getState() == 1);

                STA_TASTY_TERMINATE();
			}
		};

		void onTastyInit()
		{
			tacos::addThread<DummyThread>({0, 1, 2, 3, 4, 5, 6, 7});
		}
	} // namespace tasty
} // namespace sta

#endif // TASTY_CASE_2
