/**
 * Timed state transitions can be overwritten by timed state transitions with later deadline.
 *
 * TODO: Implement the correct requirement.
 */
#include <sta/tasty/config.hpp>
#ifdef TASTY_CASE_5

#include <sta/tacos.hpp>
#include <sta/tasty/utils.hpp>

namespace sta
{
	namespace tasty
	{
		class DummyThread : public tacos::TacosThread
		{
		public:
			DummyThread()
				: tacos::TacosThread{"Dummy", osPriorityNormal}
			{}

			void func() override 
			{
				STA_TASTY_INIT();

				STA_TASTY_ASSERT(tacos::getState() == 0);

                // Schedule a state transition in 50 ticks.
                tacos::setStateTimed(0, 1, 50);

                this->sleep(10);

                // Force a state transition now. This should override the timed transition.
                tacos::requestState(0, 2);
                STA_TASTY_ASSERT(tacos::getState() == 2);

                this->sleep(41);

                // The timed transition should have triggered now but shouldn't have any effect.
                STA_TASTY_ASSERT(tacos::getState() == 2);

                STA_TASTY_TERMINATE();
			}
		};

		void onTastyInit()
		{
			tacos::addThread<DummyThread>({0, 1, 2, 3, 4, 5, 6, 7});
		}
	} // namespace tasty
} // namespace sta

#endif // TASTY_CASE_5
